=== debian/changelog ===
proxysql2 (2.1.1) unstable; urgency=medium

  * Update to new upstream release Proxysql 2.1.1-1.1

 -- ubuntu-cloud-user <evgeniy.patlan@percona.com>  Wed, 07 Jul 2021 08:44:32 +0000

proxysql2 (2.1.1) unstable; urgency=low

  * Initial Release.

 -- EvgeniyPatlan <evgeniy.patlan@percona.com>  mon, 01 Feb 2021 07:41:56 -0400
